# ../addons/eventscripts/eventscripts_extensions/events/client_keypress/client_keypress.py


""" IMPORTS """
import es
import cmdlib
import keyfile

import os

import psyco
psyco.full()


""" GLOBALS """
eventscripts_extensions = es.import_addon('eventscripts_extensions')


""" INITIALIZATION """
def load():
    initialize()
    es.loadevents('declare', 'addons/eventscripts/eventscripts_extensions/events/client_keypress/client_keypress_ressources.res')
    es.addons.registerClientCommandFilter(ClientCommandFilterCallBack)
    
def initialize():
    global outputs
    outputs = dict()
    try:
        outputs = keyfile.Parse(os.path.join(eventscripts_extensions.informations.path, 'events', 'client_keypress', 'client_keypress_outputs.txt'))
    except:
        pass
    es.loadevents('addons/eventscripts/eventscripts_extensions/events/client_keypress/client_keypress_ressources.res')
    
def unload():
    es.addons.unregisterClientCommandFilter(ClientCommandFilterCallBack)
    
    
""" UTILITIES """
def fireClientKeypressEvent(userid, keyname, status):
    if es.getInt('eventscripts_noisy'):
        es.event('initialize', 'client_keypress')
        es.event('setint', 'client_keypress', 'userid', userid)
        es.event('setstring', 'client_keypress', 'keyname', keyname)
        es.event('setint', 'client_keypress', 'status', status)
        es.event('fire', 'client_keypress')
        
        
""" CALLBACKS """
def ClientCommandFilterCallBack(userid, arguments):
    returnvalue = True
    if len(arguments[0]) > 1 and arguments[0][0] in ('+', '-'):
        if not es.exists('clientcommand', arguments[0]):
            returnvalue = False
        fireClientKeypressEvent(userid, arguments[0][1:].lower(), 1 if arguments[0][0] == '+' else 0)
    return returnvalue
    
    
""" EVENTS """
def es_map_start(event_var):
    initialize()
    
def player_spawn(event_var):
    if int(event_var['es_userteam']) > 1:
        userid = int(event_var['userid'])
        eventscripts_lastgive = es.getString('eventscripts_lastgive')
        if es.getentityindex('client_keypress_point_servercommand') == -1:
            es.server.insertcmd('es_xcreateentity point_servercommand;' +
                'es_entitysetvalue server_var(eventscripts_lastgive) classname client_keypress_point_servercommand;' +
                'es_spawnentity server_var(eventscripts_lastgive)')
        classname = 'client_keypress_game_ui_%s' % userid
        if es.getentityindex(classname) == -1:
            es.server.insertcmd('es_xgive %s game_ui;' % userid +
                'es_entitysetvalue server_var(eventscripts_lastgive) classname %s;' % classname +
                'es_entitysetvalue server_var(eventscripts_lastgive) targetname server_var(eventscripts_lastgive);' +
                'es_entitysetvalue server_var(eventscripts_lastgive) fieldofview -1')
            for x in outputs:
                es.server.insertcmd('es_fire %s server_var(eventscripts_lastgive) addoutput "%s client_keypress_point_servercommand,command,xcallblock eventscripts_extensions/events/client_keypress/fireClientKeypressEvent %s %s %s' % (userid, x, userid, outputs[x]['keyname'], outputs[x]['status']))
            es.server.insertcmd('es_fire %s server_var(eventscripts_lastgive) activate;' % userid +
                'es_xset eventscripts_lastgive %s' % eventscripts_lastgive)
                
def player_death(event_var):
    userid = int(event_var['userid'])
    es.server.insertcmd('es_xfire %s %s kill' % (userid, es.getentityindex('client_keypress_game_ui_%s' % userid)))
    
def player_disconnect(event_var):
    userid = int(event_var['userid'])
    es.server.insertcmd('es_xfire %s %s kill' % (userid, es.getentityindex('client_keypress_game_ui_%s' % userid)))