# ../addons/eventscripts/eventscripts_extensions/eventscripts_extensions.py


""" IMPORTS """
import es
import playerlib

import os

import psyco
psyco.full()


""" INFORMATIONS """
informations = es.AddonInfo()
informations.name = 'EventScripts eXtensions for CSS OrangeBox'
informations.basename = 'eventscripts_extensions'
informations.version = '0.1c'
informations.author = 'L\'In20Cible'
informations.description = 'Provides a lot of tools for EventScriptors.'
informations.url = 'http://addons.eventscripts.com/addons/user/27382/'
informations.path = os.path.join(es.getString('eventscripts_addondir'), informations.basename).replace(os.sep, '/')

es.ServerVar('eventscripts_extensions_version', '%s by %s' % (informations.version, informations.author), informations.description).makepublic()


""" GLOBALS """
addons = list()


""" INITIALIZATION """
def load():
    initialize()
    echo('Successfully loaded.')
    
def initialize():
    eventscripts_debug = es.getString('eventscripts_debug')
    es.set('eventscripts_debug', '-1')
    for x in ('events', 'modules'):
        directory = os.path.join(informations.path, x)
        if os.path.isdir(directory):
            path = os.path.join(directory, '__init__.py')
            if not os.path.isfile(path):
                open(path, 'w').close()
            for y in os.listdir(directory):
                path = os.path.join(informations.basename, x, y).replace(os.sep, '/')
                if path not in addons and path not in getAddonList():
                    if os.path.isfile(os.path.join(directory, y, '%s.py' % y)) or os.path.isfile(os.path.join(directory, y, 'es_%s.txt' % y)):
                        es.load(path)
                        addons.append(path)
    es.set('eventscripts_debug', eventscripts_debug)
    echo('Successfully initialized.')
    
def unload():
    for x in addons:
        if x in getAddonList():
            es.unload(x)
    echo('Successfully unloaded.')
    
    
""" UTILITIES """
def echo(message):
    es.printmsg('[EventScripts eXtensions] %s\n' % message)
    
def getAddonList():
    returnvalue = list()
    for x in es.addons.getAddonList():
        returnvalue.append(x.__name__.rsplit('.', 1)[0].replace('.', '/'))
    return returnvalue + es.createscriptlist().keys()