# ../addons/eventscripts/eventscripts_extensions/modules/xgetviewprop/xgetviewprop.py


""" IMPORTS """
import es
import cmdlib

import psyco
psyco.full()


""" GLOBALS """
players = dict()
eventscripts_extensions = es.import_addon('eventscripts_extensions')


""" INITIALIZATION """
def load():
    cmdlib.registerServerCommand('xgetviewprop', ServerCommandCallBack, 'Syntax: xgetviewprop <variable> <userid>')
    
def unload():
    cmdlib.unregisterServerCommand('xgetviewprop')
    
    
""" UTILITIES """
def setViewProp(variable, userid):
    variable = es.ServerVar(variable, '-1')
    variable.set('-1')
    if userid in players:
        targetname = 'xviewed_prop_%s' % userid
        for x in players[userid]:
            if es.entitygetvalue(x, 'targetname') == targetname:
                variable.set(str(x))
                es.entitysetvalue(x, 'targetname', players[userid][x]['targetname'])
                break
        del players[userid]
        
        
""" CALLBACKS """
def ServerCommandCallBack(arguments):
    if len(arguments) == 2:
        userid = str(es.getuserid(arguments[1]))
        if es.exists('userid', userid):
            players[userid] = es.createentityindexlist()
            for x in players[userid]:
                players[userid][x]['targetname'] = es.entitygetvalue(x, 'targetname')
            es.server.insertcmd('es_xentsetname %s xviewed_prop_%s;' % (userid, userid) +
                'xcallblock eventscripts_extensions/modules/xgetviewprop/setViewProp %s %s' % (arguments[0], userid))
        else:
            eventscripts_extensions.echo('Unable to find player matching with "%s".' % arguments[1])
    else:
        eventscripts_extensions.echo('Syntax: xgetviewprop <variable> <userid>')
        
        
""" EVENTS """
def player_disconnect(event_var):
    if event_var['userid'] in players:
        del players[event_var['userid']]